var DigitalEditionReader =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// install a JSONP callback for chunk loading
/******/ 	function webpackJsonpCallback(data) {
/******/ 		var chunkIds = data[0];
/******/ 		var moreModules = data[1];
/******/ 		var executeModules = data[2];
/******/ 		// add "moreModules" to the modules object,
/******/ 		// then flag all "chunkIds" as loaded and fire callback
/******/ 		var moduleId, chunkId, i = 0, resolves = [];
/******/ 		for(;i < chunkIds.length; i++) {
/******/ 			chunkId = chunkIds[i];
/******/ 			if(installedChunks[chunkId]) {
/******/ 				resolves.push(installedChunks[chunkId][0]);
/******/ 			}
/******/ 			installedChunks[chunkId] = 0;
/******/ 		}
/******/ 		for(moduleId in moreModules) {
/******/ 			if(Object.prototype.hasOwnProperty.call(moreModules, moduleId)) {
/******/ 				modules[moduleId] = moreModules[moduleId];
/******/ 			}
/******/ 		}
/******/ 		if(parentJsonpFunction) parentJsonpFunction(data);
/******/ 		while(resolves.length) {
/******/ 			resolves.shift()();
/******/ 		}
/******/
/******/ 		// add entry modules from loaded chunk to deferred list
/******/ 		deferredModules.push.apply(deferredModules, executeModules || []);
/******/
/******/ 		// run deferred modules when all chunks ready
/******/ 		return checkDeferredModules();
/******/ 	};
/******/ 	function checkDeferredModules() {
/******/ 		var result;
/******/ 		for(var i = 0; i < deferredModules.length; i++) {
/******/ 			var deferredModule = deferredModules[i];
/******/ 			var fulfilled = true;
/******/ 			for(var j = 1; j < deferredModule.length; j++) {
/******/ 				var depId = deferredModule[j];
/******/ 				if(installedChunks[depId] !== 0) fulfilled = false;
/******/ 			}
/******/ 			if(fulfilled) {
/******/ 				deferredModules.splice(i--, 1);
/******/ 				result = __webpack_require__(__webpack_require__.s = deferredModule[0]);
/******/ 			}
/******/ 		}
/******/ 		return result;
/******/ 	}
/******/
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// object to store loaded and loading chunks
/******/ 	// undefined = chunk not loaded, null = chunk preloaded/prefetched
/******/ 	// Promise = chunk loading, 0 = chunk loaded
/******/ 	var installedChunks = {
/******/ 		"edition-reader": 0
/******/ 	};
/******/
/******/ 	// script path function
/******/ 	function jsonpScriptSrc(chunkId) {
/******/ 		return __webpack_require__.p + "" + ({}[chunkId]||chunkId) + ".js"
/******/ 	}
/******/
/******/ 	var deferredModules = [];
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	var jsonpArray = window["webpackJsonpDigitalEditionReader"] = window["webpackJsonpDigitalEditionReader"] || [];
/******/ 	var oldJsonpFunction = jsonpArray.push.bind(jsonpArray);
/******/ 	jsonpArray.push = webpackJsonpCallback;
/******/ 	jsonpArray = jsonpArray.slice();
/******/ 	for(var i = 0; i < jsonpArray.length; i++) webpackJsonpCallback(jsonpArray[i]);
/******/ 	var parentJsonpFunction = oldJsonpFunction;
/******/
/******/
/******/ 	// add entry module to deferred list
/******/ 	deferredModules.push([0,"edition-reader-vendor"]);
/******/ 	// run deferred modules when ready
/******/ 	return checkDeferredModules();
/******/ })
/************************************************************************/
/******/ ({

/***/ "./src/js/digital-edition-reader.jsx":
/*!*******************************************!*\
  !*** ./src/js/digital-edition-reader.jsx ***!
  \*******************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
eval("\n\nObject.defineProperty(exports, \"__esModule\", {\n    value: true\n});\nexports.DigitalEditionReader = undefined;\n\nvar _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };\n\nvar _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if (\"value\" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();\n\nexports.install = install;\n\nvar _react = __webpack_require__(/*! react */ \"./node_modules/react/index.js\");\n\nvar _react2 = _interopRequireDefault(_react);\n\nvar _reactDom = __webpack_require__(/*! react-dom */ \"./node_modules/react-dom/index.js\");\n\nvar _reactDom2 = _interopRequireDefault(_reactDom);\n\nvar _popupReader = __webpack_require__(/*! ./popup-reader */ \"./src/js/popup-reader.jsx\");\n\nvar _popupReader2 = _interopRequireDefault(_popupReader);\n\nfunction _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }\n\nfunction _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError(\"Cannot call a class as a function\"); } }\n\nfunction _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError(\"this hasn't been initialised - super() hasn't been called\"); } return call && (typeof call === \"object\" || typeof call === \"function\") ? call : self; }\n\nfunction _inherits(subClass, superClass) { if (typeof superClass !== \"function\" && superClass !== null) { throw new TypeError(\"Super expression must either be null or a function, not \" + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }\n\n/**\n * The DigitalEditionReader is the main class for loading the\n * reader component.\n */\nvar DigitalEditionReader = exports.DigitalEditionReader = function (_React$Component) {\n    _inherits(DigitalEditionReader, _React$Component);\n\n    function DigitalEditionReader(props) {\n        _classCallCheck(this, DigitalEditionReader);\n\n        var _this = _possibleConstructorReturn(this, (DigitalEditionReader.__proto__ || Object.getPrototypeOf(DigitalEditionReader)).call(this, props));\n\n        _this.state = _extends({\n            displayReader: 'none',\n            openReaderLabel: 'Start Reading',\n            visibleAnnotations: [],\n            text: '',\n            annotations: []\n        }, props.options);\n        if (_this.state.displayReader !== 'none') {\n            document.querySelector('body').classList.add('popup-reader-active');\n        }\n        return _this;\n    }\n\n    _createClass(DigitalEditionReader, [{\n        key: 'componentDidMount',\n        value: function componentDidMount() {\n            if (this.state.annotations && this.state.annotations.length > 0) {\n                this.loadAnnotations(this.state.annotations);\n            } else {\n                this.setState({\n                    parsedText: this.state.text\n                });\n            }\n        }\n    }, {\n        key: 'loadAnnotations',\n        value: function loadAnnotations(annotations) {\n            var parser = new DOMParser();\n            var dom = parser.parseFromString(this.state.text, 'text/html');\n            annotations.forEach(function (annotation) {\n                annotation.target.forEach(function (target) {\n                    target.selector.value.forEach(function (selectorValue) {\n                        var nodes = dom.querySelectorAll(\"*[about='\" + selectorValue.id + \"'][typeof='\" + selectorValue.type + \"']\");\n                        if (target.selector.refinedBy && target.selector.refinedBy.length > 0) {\n                            target.selector.refinedBy.forEach(function (refineValue) {\n                                if (refineValue.type === 'TextPositionSelector') {\n                                    nodes.forEach(function (node) {\n                                        var html = node.innerHTML;\n                                        var pos = 0;\n                                        var counting = true;\n                                        var mode = 0;\n                                        var prefix = '';\n                                        var content = '';\n                                        var postfix = '';\n                                        var buffer = [];\n                                        for (var idx = 0; idx < html.length; idx++) {\n                                            if (pos === refineValue.start && mode == 0) {\n                                                prefix = buffer.join('');\n                                                mode = 1;\n                                                buffer = [];\n                                            } else if (pos === refineValue.end && mode == 1) {\n                                                content = buffer.join('');\n                                                mode = 2;\n                                                buffer = [];\n                                            }\n                                            buffer.push(html[idx]);\n                                            if (html[idx] === '<') {\n                                                counting = false;\n                                            } else if (html[idx] === '>') {\n                                                counting = true;\n                                            } else if (counting) {\n                                                pos = pos + 1;\n                                            }\n                                        }\n                                        postfix = buffer.join('');\n                                        html = prefix + '<a href=\"#\" data-annotation-id=\"' + annotation.id + '\" class=\"toggle-annotation\">' + content + '</a>' + postfix;\n                                        node.innerHTML = html;\n                                    });\n                                }\n                            });\n                        }\n                    });\n                });\n            });\n            this.setState({\n                annotations: annotations,\n                parsedText: dom.querySelector('body').innerHTML\n            });\n        }\n\n        /**\n         * Handle clicks to show the PopupReader.\n         */\n\n    }, {\n        key: 'onClickPopupReaderOpen',\n        value: function onClickPopupReaderOpen(ev) {\n            ev.preventDefault();\n            this.setState({\n                displayReader: 'block'\n            });\n            document.querySelector('body').classList.add('popup-reader-active');\n        }\n\n        /**\n         * Handle clicks to close the PopupReader.\n         */\n\n    }, {\n        key: 'onClickPopupReaderClose',\n        value: function onClickPopupReaderClose(ev) {\n            ev.preventDefault();\n            this.setState({\n                displayReader: 'none'\n            });\n            document.querySelector('body').classList.remove('popup-reader-active');\n        }\n\n        /**\n         * Handle the user clicking on an annotation link to show/hide the annotation.\n         */\n\n    }, {\n        key: 'onClickToggleAnnotation',\n        value: function onClickToggleAnnotation(ev) {\n            ev.preventDefault();\n            if (ev.target.dataset.annotationId) {\n                var visibleAnnotations = this.state.visibleAnnotations;\n                if (visibleAnnotations.indexOf(ev.target.dataset.annotationId) >= 0) {\n                    visibleAnnotations.splice(visibleAnnotations.indexOf(ev.target.dataset.annotationId), 2);\n                } else {\n                    visibleAnnotations.push(ev.target.dataset.annotationId);\n                }\n                this.setState({\n                    visibleAnnotations: visibleAnnotations\n                });\n            }\n        }\n\n        /**\n         * Render the component\n         */\n\n    }, {\n        key: 'render',\n        value: function render() {\n            return _react2.default.createElement(\n                'div',\n                null,\n                _react2.default.createElement(\n                    'button',\n                    { className: 'popup-reader-open', onClick: this.onClickPopupReaderOpen.bind(this) },\n                    this.state.openReaderLabel\n                ),\n                _react2.default.createElement(_popupReader2.default, { text: this.state.parsedText, annotations: this.state.annotations, visibleAnnotations: this.state.visibleAnnotations, display: this.state.displayReader, onCloseClick: this.onClickPopupReaderClose.bind(this), onClickToggleAnnotation: this.onClickToggleAnnotation.bind(this) })\n            );\n        }\n    }]);\n\n    return DigitalEditionReader;\n}(_react2.default.Component);\n\n;\n\n/**\n * The install function attaches a new DigitalEditionReader at the give}n\n * attachmentPoint with the specified options.\n */\nfunction install(attachmentPoint, options, callback) {\n    _reactDom2.default.render(_react2.default.createElement(DigitalEditionReader, { ref: function ref(component) {\n            if (callback) {\n                callback(component);\n            }\n        }, options: options }), attachmentPoint);\n}\n\n//# sourceURL=webpack://DigitalEditionReader/./src/js/digital-edition-reader.jsx?");

/***/ }),

/***/ "./src/js/popup-reader.jsx":
/*!*********************************!*\
  !*** ./src/js/popup-reader.jsx ***!
  \*********************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
eval("\n\nObject.defineProperty(exports, \"__esModule\", {\n    value: true\n});\nexports.default = PopupReader;\n\nvar _react = __webpack_require__(/*! react */ \"./node_modules/react/index.js\");\n\nvar _react2 = _interopRequireDefault(_react);\n\nfunction _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }\n\n/**\n * The PopupReader provides the actual reader component. Currently only contains\n * demo data.\n */\nfunction PopupReader(props) {\n    function noAction(ev) {\n        ev.preventDefault();\n        ev.stopPropagation();\n    }\n    var annotations = props.annotations.map(function (annotation) {\n        if (props.visibleAnnotations.indexOf(annotation.id) >= 0) {\n            var annotationTitle = null;\n            var annotationBody = null;\n            annotation.body.forEach(function (body) {\n                if (body.purpose === 'title') {\n                    annotationTitle = body.value;\n                } else if (body.purpose === 'body') {\n                    annotationBody = body.value;\n                }\n            });\n            return _react2.default.createElement(\n                'div',\n                { key: annotation.id, className: 'popup-reader-annotation' },\n                _react2.default.createElement(\n                    'div',\n                    null,\n                    _react2.default.createElement(\n                        'h1',\n                        { className: 'popup-reader-annotation-title' },\n                        annotationTitle\n                    ),\n                    _react2.default.createElement(\n                        'div',\n                        { className: 'popup-reader-annotation-close' },\n                        _react2.default.createElement(\n                            'a',\n                            { href: '#', onClick: props.onClickToggleAnnotation, 'data-annotation-id': annotation.id },\n                            '\\xD7'\n                        )\n                    )\n                ),\n                _react2.default.createElement(\n                    'p',\n                    null,\n                    annotationBody\n                )\n            );\n        } else {\n            return null;\n        }\n    });\n    return _react2.default.createElement(\n        'div',\n        { className: 'popup-reader-overlay', style: { display: props.display }, onClick: props.onCloseClick },\n        _react2.default.createElement(\n            'div',\n            { className: 'popup-reader', onClick: noAction },\n            _react2.default.createElement('section', { className: 'popup-reader-text', dangerouslySetInnerHTML: { __html: props.text }, onClick: props.onClickToggleAnnotation }),\n            _react2.default.createElement(\n                'section',\n                { className: 'popup-reader-annotations' },\n                annotations\n            )\n        )\n    );\n}\n\n//# sourceURL=webpack://DigitalEditionReader/./src/js/popup-reader.jsx?");

/***/ }),

/***/ 0:
/*!*************************************************!*\
  !*** multi ./src/js/digital-edition-reader.jsx ***!
  \*************************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

eval("module.exports = __webpack_require__(/*! /home/mhall/Projects/gutzkow/digital-edition-reader/src/js/digital-edition-reader.jsx */\"./src/js/digital-edition-reader.jsx\");\n\n\n//# sourceURL=webpack://DigitalEditionReader/multi_./src/js/digital-edition-reader.jsx?");

/***/ })

/******/ });